using System;
using System.Collections.Generic;
using System.Text;
using Artech.MyRemoting.RemoteService;
using System.Runtime.Remoting;
using System.Threading;

namespace Artech.MyRemoting.Client
{
    class Program
    {
        static void Main(string[] args)
        {
            string singelCallAddress = "http://localhost:1234/artech.myremoting/singlecall.calculator.rem";
            string singletonAddress = "http://localhost:1234/artech.myremoting/singleton.calculator.rem";
            string caoAddress = "http://localhost:1234/artech.myremoting";

            RemotingConfiguration.RegisterActivatedClientType(typeof(CalculatorService), caoAddress);

            Console.WriteLine("Create server SingleCall proxy at {0}", DateTime.Now.ToString("hh:mm:ss"));
            CalculatorService singleCallCalculator = Activator.GetObject(typeof(CalculatorService), singelCallAddress) as CalculatorService;

            Thread.Sleep(10000);
            Console.WriteLine("Create server Singleton proxy at {0}", DateTime.Now.ToString("hh:mm:ss"));
            CalculatorService singletonCalculator = Activator.GetObject(typeof(CalculatorService), singletonAddress) as CalculatorService;

            Thread.Sleep(10000);
            Console.WriteLine("\nCreate client activated object proxy at {0}", DateTime.Now.ToString("hh:mm:ss"));
            CalculatorService caoCalculator = new CalculatorService();

            Thread.Sleep(10000);
            Console.WriteLine("\nCall the method of SingleCall object at {0}", DateTime.Now.ToString("hh:mm:ss"));
            InvocateCalculator(singleCallCalculator);

            Thread.Sleep(10000);
            Console.WriteLine("\nCall the method of Singleton object at {0}", DateTime.Now.ToString("hh:mm:ss"));
            InvocateCalculator(singletonCalculator);

            Thread.Sleep(10000);
            Console.WriteLine("\nCall the method of CAO object at {0}", DateTime.Now.ToString("hh:mm:ss"));
            InvocateCalculator(caoCalculator);

           
            Console.WriteLine("The times to invovate the current SingleCall remote object is {0}", singleCallCalculator.GetCallCount());
            Console.WriteLine("The times to invovate the current Singleton remote object is {0}", singletonCalculator.GetCallCount());
            Console.WriteLine("The times to invovate the current CAO remote object is {0}", caoCalculator.GetCallCount());

            Console.Read();
        }

        static void InvocateCalculator(CalculatorService calculator)
        { 
            Console.WriteLine("x + y = {2} where x = {0} and y = {1}",1,2,calculator.Add(1,2));
        }
    }
}
